// Copyright (c) 1998 Savvy Software
// Created by Matthijs Hollemans
// All Rights Reserved

// ***************************************************************************
// Implementation System Includes
// ***************************************************************************

// ***************************************************************************
// Implementation Project Includes
// ***************************************************************************

#include "Fit.h"

// ***************************************************************************
// Implementation Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Type Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Variable Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Function Declarations
// ***************************************************************************

/** Calculates the conversion factor for a certain font. */
static inline tFloat CalcFactor(const BFont* apFont);

// ***************************************************************************
// Global Variable Definitions
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Lifecycle
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Operators
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Operations
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Access
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Inquiry
// ***************************************************************************

// ***************************************************************************
// PROTECTED Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// PRIVATE Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Definitions
// ***************************************************************************

// ***************************************************************************
// Global Function Definitions
// ***************************************************************************

// ===========================================================================
// Goowee_Fit BRect
// ===========================================================================

BRect 
Goowee_Fit(BRect aRect, const BFont* apFont) 
{
  tFloat lFactor = CalcFactor(apFont);
  aRect.left   *= lFactor;
  aRect.right  *= lFactor;
  aRect.top    *= lFactor;
  aRect.bottom *= lFactor;
  return aRect;  
}

// ===========================================================================
// Goowee_Fit BPoint
// ===========================================================================

BPoint 
Goowee_Fit(BPoint aPoint, const BFont* apFont) 
{
  tFloat lFactor = CalcFactor(apFont);
  aPoint.x *= lFactor;
  aPoint.y *= lFactor;
  return aPoint;  
}

// ===========================================================================
// Goowee_Fit floating point value
// ===========================================================================

tFloat 
Goowee_Fit(tFloat aFloat, const BFont* apFont) 
{
  return aFloat *= CalcFactor(apFont);
}

// ***************************************************************************
// Implementation Function Definitions
// ***************************************************************************

// ===========================================================================
// CalcFactor
// ===========================================================================

static inline tFloat 
CalcFactor(const BFont* apFont) 
{
  return apFont->Size() / GOOWEE_FIT_DEFAULT_FONT_SIZE;
}
