// Copyright (c) 1998 Savvy Software
// Created by Matthijs Hollemans
// All Rights Reserved

#ifndef TRACKERGREP_WINDOW_H
#define TRACKERGREP_WINDOW_H

// ***************************************************************************
// System Includes
// ***************************************************************************

// ***************************************************************************
// Project Includes
// ***************************************************************************

#include "StyleGuideDefs.h"          // Standard type and constant definitions

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

/**  
 * The main window.
 */
class tWindow : public BWindow {
public:
  // Constant Definitions ====================================================

  // Type Definitions ========================================================

  // Attribute Definitions ===================================================

  // Member Function Definitions =============================================
 
  // Lifecycle ---------------------------------------------------------------

  /** Constructor. */
  tWindow(); 

  /** Automatically generated copy constructor. */
  // tWindow(const tWindow& arOld);

  /** Automatically generated destructor. */
  // ~tWindow();

  // Operators ---------------------------------------------------------------

  /** Automatically generated assignment operator. */
  // tWindow& operator=(tWindow& arRight);

  // Operations --------------------------------------------------------------

  /** Handles the messages that the window receives. */
  virtual void MessageReceived(BMessage* apMessage);

  // Access ------------------------------------------------------------------

  // Inquiry -----------------------------------------------------------------

protected:
  // Constant Definitions ====================================================

  // Type Definitions ========================================================

  // Attribute Definitions ===================================================

  // Member Function Definitions =============================================

private:
  // Constant Definitions ====================================================

  // Type Definitions ========================================================

  // Attribute Definitions ===================================================
  
  /** Pointer to the entry field of the search pattern. */
  BTextControl* mpSearchText;
  
  /** Pointer to the view that will display the results of the search. */
  BTextView* mpSearchResults;

  /** Pointer to the "subdirectories" check box. */
  BCheckBox* mpRecurseDirs;

  /** Pointer to the "links" check box. */
  BCheckBox* mpRecurseLinks;
  
  /** Pointer to the "search/cancel" button object. */
  BButton* mpButton;
  
  // Member Function Definitions =============================================
};

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

#endif // TRACKERGREP_WINDOW_H
